SystemOrganization addCategory: #GODBases!

Object subclass: #GDBData
	instanceVariableNames: 'timestamp origin author title content tags width height layoutGrid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODBases'!

!GDBData commentStamp: 'lacm 10/19/2014 16:21' prior: 0!
A GDBData contains the abstract GODData model.!

!GDBData class methodsFor: 'adding' stamp: 'lacm 10/19/2014 15:17'!
addTimestamp: aTimestamp	addOrigin: anOrigin	addAuthor: anAuthor	addTitle: aTitle	addContent: aContent	addTags: anOrderedCollectionTag	addWidth: aWidth	addHeight: aHeight	addLayoutGridRowSize: aRowNumber addColumnSize: aColumnNumber
				
	^ self new timestamp: aTimestamp;
	                 origin: anOrigin;
				author: anAuthor;
				title: aTitle;
				content: aContent;
				tags: anOrderedCollectionTag;
				width: aWidth;
				height: aHeight;	 yourself! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:32'!
author	
	^ author! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:32'!
author: aString	
	author := aString! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:33'!
content	
	^ content! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:33'!
content: aString	
	content := aString! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:36'!
height	
	^ height! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:36'!
height: anInteger	
	height := anInteger! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:36'!
layoutGrid	
	^ layoutGrid! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:37'!
layoutGridRowSize: rowNumber columnSize: columnNumber	
	
	"creating a new layoutGrid"	
	layoutGrid := Matrix rows: rowNumber columns: columnNumber.! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:31'!
origin	
	^ origin! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:31'!
origin: aString	
	origin := aString! !

!GDBData methodsFor: 'as yet unclassified' stamp: 'lacm 10/19/2014 15:23'!
printOn: aStream
	aStream nextPutAll: 'Timestamp: ' , timestamp,
						' - Origin: ', origin, 
						' - Author: ', author, 
						' - Title: ', title,
						' - Content: ', content,
						' - Tags: ', tags,
						' - Width: ', width,
						' - Height: ', height,
						' - LayoutGrid: ', layoutGrid
					 ! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:33'!
tags	
	^ tags! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:35'!
tags: anOrderedCollectionTag		
"		(anOrderedCollectionTag isMemberOf: OrderedCollection)		
			ifTrue: [tags := anOrderedCollectionTag]		
			ifFalse: [GODDataTagMustBeAnOrderedCollection signal]	"
				
	tags := anOrderedCollectionTag! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:30'!
timestamp
	^ timestamp! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:30'!
timestamp: aDate	
	timestamp := aDate! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:32'!
title	
	^ title! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:33'!
title: aString	
	title := aString! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:35'!
width	
	^ width! !

!GDBData methodsFor: 'accessing' stamp: 'lacm 10/19/2014 14:35'!
width: anInteger	
	width := anInteger! !

Object subclass: #GDBDataBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODBases'!

!GDBDataBase class methodsFor: 'as yet unclassified' stamp: 'lacm 10/19/2014 11:58'!
database
	^ GDBMagmaClient root at: 'gdbdata'.! !

Object subclass: #GDBMagmaClient
	instanceVariableNames: 'session'
	classVariableNames: 'DefaultConnection'
	poolDictionaries: ''
	category: 'GODBases'!

!GDBMagmaClient commentStamp: 'lacm 10/19/2014 19:26' prior: 0!
Before following these instructions, first set up your server in a separate running image by following the instructions in the class comment of GDBMagmaServer.

After you have the server running, switch back to this image and do the following.

First, run the following:	
	
	GDBMagmaClient session.
	
	GDBMagmaClient commit: [
		GDBMagmaClient root at: 'gdbdata'
							  put: OrderedCollection new.
		].
	
	GDBMagmaClient root.
	
Then, you may add data in the GDBData run the following:

  	GDBMagmaClient commit: [
		GDBDataBase database add: ( GDBData addTimestamp: '19/10/2014' addOrigin: 'my origin'
										             addAuthor: 'my favorite author' addTitle: 'some title'
												 addContent: 'my content' addTags: 'a collection of tag'
												 addWidth: 5 addHeight: 6 
												 addLayoutGridRowSize: 3 addColumnSize: 3)
		].

To visualization of the data, run the following:

	GDBDataBase database.
	
!

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 9/28/2014 20:53'!
commit: aBlock
	self default session commit: aBlock! !

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 10/15/2014 12:19'!
default
	^ DefaultConnection ifNil: [
			DefaultConnection := self new connect; 
			yourself
			].! !

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 10/15/2014 12:21'!
release
	(DefaultConnection isNil)
	ifFalse:[
			DefaultConnection session disconnectAndClose.
			DefaultConnection := nil.
		]! !

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 9/28/2014 20:52'!
root
	^ self session root! !

!GDBMagmaClient class methodsFor: 'connection' stamp: 'lacm 9/28/2014 20:52'!
session
	^ self default session! !

!GDBMagmaClient methodsFor: 'as yet unclassified' stamp: 'lacm 9/28/2014 20:50'!
connect
	session := (MagmaRemoteLocation
					host: 'localhost'
					port: 51001) newSession.
	session connectAs: 'lucy'.! !

!GDBMagmaClient methodsFor: 'private' stamp: 'lacm 9/28/2014 20:51'!
session
	^ session! !

!GDBMagmaClient methodsFor: 'private' stamp: 'lacm 10/15/2014 12:23'!
session: anObject
	session := anObject! !

Object subclass: #GDBMagmaServer
	instanceVariableNames: 'gdbServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODBases'!

!GDBMagmaServer commentStamp: 'lacm 10/19/2014 15:44' prior: 0!
To create the repository, in a workspace, run only once:
	
	GDBMagmaServer new createGDBRepository

hence, to connect the server, run only once the following line:  

	GDBMagmaServer new startGDBServer

then, save it as an image server. To close the server, close that image saved, and when you open it again, the server will already be running.!

!GDBMagmaServer methodsFor: 'createGDBRepository' stamp: 'lacm 10/15/2014 12:11'!
createGDBRepository
	MagmaRepositoryController
		create: self repositoryName
		root:  Dictionary new.! !

!GDBMagmaServer methodsFor: 'private' stamp: 'lacm 10/15/2014 12:09'!
port
	^ 51001! !

!GDBMagmaServer methodsFor: 'private' stamp: 'lacm 10/19/2014 11:56'!
repositoryName
	^ 'gdbMagmaExample2'! !

!GDBMagmaServer methodsFor: 'server' stamp: 'lacm 10/15/2014 12:25'!
startGDBServer
	gdbServer := MagmaServerConsole new
		open: self repositoryName;
		processOn: self port;
		yourself.
	self inspect! !

!GDBMagmaServer methodsFor: 'server' stamp: 'lacm 10/15/2014 12:14'!
stopGDBServer
	gdbServer shutdown! !
